export interface Map<K, V> {
    clear(): void;
    delete(key: K): boolean;
    forEach(callbackfn: (value: V, index: K, map: Map<K, V>) => void, thisArg?: any): void;
    get(key: K): V;
    has(key: K): boolean;
    set(key: K, value?: V): Map<K, V>;
    size: number;
}
export interface MapConstructor {
    new (): Map<any, any>;
    new <K, V>(): Map<K, V>;
    prototype: Map<any, any>;
}
declare var TypeMap: Map<any, any>;
export declare type Serializer = (value: any) => any;
export declare type Deserializer = (value: any) => any;
export interface ISerializable {
    Serialize?: (value: any) => any;
    Deserialize?: (json: any, instance?: any) => any;
}
export declare function CamelCase(str: string): string;
export declare function SnakeCase(str: string): string;
export declare function UnderscoreCase(str: string): string;
export declare function DashCase(str: string): string;
export declare function inheritSerialization(parentType: Function): any;
export declare function serialize(target: any, keyName: string): any;
export declare function deserialize(target: any, keyName: string): any;
export declare function autoserialize(target: any, keyName: string): any;
export declare function serializeAs(keyNameOrType: string | Serializer | ISerializable, keyName?: string): any;
export declare function serializeIndexable(type: Serializer | ISerializable, keyName?: string): any;
export declare function deserializeAs(keyNameOrType: string | Function | ISerializable, keyName?: string): any;
export declare function deserializeIndexable(type: Function | ISerializable, keyName?: string): any;
export declare function autoserializeAs(keyNameOrType: string | Function | ISerializable, keyName?: string): any;
export declare function autoserializeIndexable(type: Function | ISerializable, keyName?: string): any;
export declare function Deserialize(json: any, type?: Function | ISerializable): any;
export declare function DeserializeInto(source: any, type: Function | ISerializable, target: any): any;
export declare function Serialize(instance: any, type?: Function | ISerializable): any;
export declare function GenericDeserialize<T>(json: any, type: new () => T): T;
export declare function GenericDeserializeInto<T>(json: any, type: new () => T, instance: T): T;
export declare function DeserializeKeysFrom(transform: (key: string) => string): void;
export declare function SerializeKeysTo(transform: (key: string) => string): void;
export declare function SerializableEnumeration(e: any): void;
export { TypeMap as __TypeMap };
